package edu.prlab.tyler.iotgateway.contract;


import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.jupiter.api.BeforeEach;
import org.junit.runners.MethodSorters;
import org.web3j.protocol.core.methods.response.TransactionReceipt;
import org.web3j.protocol.core.methods.response.Web3ClientVersion;
import org.web3j.protocol.http.HttpService;
import org.web3j.quorum.Quorum;
import org.web3j.tx.ClientTransactionManager;
import org.web3j.tx.gas.ContractGasProvider;
import org.web3j.tx.gas.DefaultGasProvider;
import org.web3j.tx.gas.StaticGasProvider;

import java.math.BigInteger;

@FixMethodOrder(value = MethodSorters.NAME_ASCENDING)
public class ContractTester {

    private static final String rpcUrl = "http://localhost:22000";

//    private static final String privateKey = "7777777777777777777777777777777777777777777777777777777777777777";

    private static final ContractGasProvider DEFAULT_GAS_PROVIDER = new StaticGasProvider(
            BigInteger.ZERO,
            DefaultGasProvider.GAS_LIMIT
    );

    @BeforeClass
    public static void setUp() {
    }

    @Test
    public void test1deployDeviceContract() throws Exception {
//        Credentials credentials = Credentials.create(privateKey);
        Quorum quorum = Quorum.build(new HttpService(rpcUrl));

        Web3ClientVersion web3ClientVersion = quorum.web3ClientVersion().sendAsync().get();
        String clientVersion = web3ClientVersion.getWeb3ClientVersion();
        System.out.println("web3j版本 : " + clientVersion);

        String userAddress = quorum.ethAccounts().send().getAccounts().get(0);
        System.out.println("User : " + userAddress);

        ClientTransactionManager manager = new ClientTransactionManager(quorum, userAddress);

        DeviceContract deviceContract = DeviceContract.deploy(quorum, manager, DEFAULT_GAS_PROVIDER).send();
        String deviceContractAddress = deviceContract.getContractAddress();
        System.out.println("智慧合約地址 : " + deviceContractAddress);
        Assert.assertNotNull(deviceContract);

        TransactionReceipt deviceReceipt = deviceContract.setdeviceinfo("testdevice").send();
        System.out.println(deviceReceipt.toString());

        TransactionReceipt privacyPolicyReceipt = deviceContract.setpp("testpp").send();
        System.out.println(privacyPolicyReceipt.toString());

        String deviceInfo = deviceContract.deviceInfo().send();
        System.out.println(deviceInfo);

        String privacyPolicy = deviceContract.privacypolicy().send();
        System.out.println(privacyPolicy);

    }

    @Test
    public void test2uploadDeviceInfoAndPolicy() throws Exception {}

    @Test
    public void test3deployGatewayContract() throws Exception {}

    @Test
    public void test4bind() throws Exception {}

}
